#ifndef FRAMECPP__COMMON__Description_HH
#define FRAMECPP__COMMON__Description_HH

#include <list>

#include "framecpp/Common/FrameSpec.hh"

namespace FrameCPP
{
  namespace Common
  {
    class OFrameStream;

    class Description
    {
    public:
      virtual ~Description( );

      const std::string& GetName( ) const;

      void Write( OFrameStream& Stream ) const;

      void operator( )( const FrameSpec::Object& Obj );

      INT_4U size( ) const;

    private:
      typedef std::list< FrameSpec::Object* > description_container;

      description_container	m_desc;
    };

    inline INT_4U Common::Description::
    size( ) const
    {
      return m_desc.size( );
    }

  } // namespace - Common
} // namespace - FrameCPP

#endif /* FRAMECPP__COMMON__Description_HH */

